/* -*-c-*-
 *
 * Internal structures for built-in fields
 *
 * (c) 2004 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------*
 *
 * This file is part of Catacomb.
 *
 * Catacomb is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * Catacomb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with Catacomb; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#ifndef CATACOMB_FIELD_GUTS_H
#define CATACOMB_FIELD_GUTS_H

#ifdef __cplusplus
  extern "C" {
#endif

/*----- Header files ------------------------------------------------------*/

#ifndef CATACOMB_MP_H
#  include "mp.h"
#endif

#ifndef CATACOMB_EC_H
#  include "ec.h"
#endif

#ifndef CATACOMB_MPMONT_H
#  include "mpmont.h"
#endif

#ifndef CATACOMB_MPREDUCE_H
#  include "mpreduce.h"
#endif

#ifndef CATACOMB_GF_H
#  include "gf.h"
#endif

#ifndef CATACOMB_GFN_H
#  include "gfn.h"
#endif

#ifndef CATACOMB_GFREDUCE_H
#  include "gfreduce.h"
#endif

#ifndef CATACOMB_FIELD_H
#  include "field.h"
#endif

/*----- Data structures ---------------------------------------------------*/

typedef struct fctx_prime {
  field f;
  mpmont mm;
} fctx_prime;

typedef struct fctx_niceprime {
  field f;
  mpreduce r;
} fctx_niceprime;

typedef struct fctx_binpoly {
  field f;
  gfreduce r;
} fctx_binpoly;

typedef struct fctx_binnorm {
  fctx_binpoly f;
  gfn ntop, pton;
} fctx_binnorm;

/*----- That's all, folks -------------------------------------------------*/

#ifdef __cplusplus
  }
#endif

#endif
