/* -*-c-*-
 *
 * Internal structures for built-in groups
 *
 * (c) 2004 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------*
 *
 * This file is part of Catacomb.
 *
 * Catacomb is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * Catacomb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with Catacomb; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#ifndef CATACOMB_GROUP_GUTS_H
#define CATACOMB_GROUP_GUTS_H

#ifdef __cplusplus
  extern "C" {
#endif

/*----- Header files ------------------------------------------------------*/

#ifndef CATACOMB_MP_H
#  include "mp.h"
#endif

#ifndef CATACOMB_EC_H
#  include "ec.h"
#endif

#ifndef CATACOMB_MPMONT_H
#  include "mpmont.h"
#endif

#ifndef CATACOMB_GFREDUCE_H
#  include "gfreduce.h"
#endif

#define GROUP_GUTS_MPSTRUCT
typedef struct { mp *x; } ge_prime;
typedef struct { mp *x; } ge_bin;

#ifndef CATACOMB_GROUP_H
#  include "group.h"
#endif

/*----- Data structures ---------------------------------------------------*/

typedef struct gctx_prime {
  struct group_ g;
  ge_prime gen;
  mpmont mm;
  ge_prime i;
} gctx_prime;

typedef struct gctx_ec {
  struct group_ g;
  ec id, gen;
  ec_info ei;
} gctx_ec;

typedef struct gctx_bin {
  struct group_ g;
  ge_bin gen;
  ge_bin one;
  gfreduce r;
} gctx_bin;

/*----- That's all, folks -------------------------------------------------*/

#ifdef __cplusplus
  }
#endif

#endif
